﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Configuration;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using WcfTwoWay.Interfaces;

namespace WcfTwoWay.Client
{
    public partial class MainForm : Form
    {
        // Implémentation d'un dico de callback. Normalement on fonctionnerait avec un seul call back par exécutable
        // On a 4 callbacks pour simuler 4 clients en même temps sans avoir besoin de lancer 4 exe
        Dictionary<string, CallBack> _lstCallBacks = new Dictionary<string, CallBack>();

        public MainForm()
        {
            InitializeComponent();
        }

        private void btnConnecter_Click(object sender, EventArgs e)
        {
            string nom = (sender as Control).Tag.ToString();
            
            _lstCallBacks[nom] = new CallBack() { Nom =  nom};
            _lstCallBacks[nom].ReceptionMessage += MainForm_ReceptionMessage;

            // Comme IServeur implémente un CallBack, on doit passer par un DuplexChannelFactory (sur du Wcf standard, on utiliserait un ChannelFactory
            // TODO : mettre ca dans le app.config
            var factory = new DuplexChannelFactory<IServeur>(_lstCallBacks[nom]);
            factory.Endpoint.Address = new EndpointAddress("net.tcp://localhost:12345");
            factory.Endpoint.Binding = new NetTcpBinding();
            factory.Open();
            var c = factory.CreateChannel(new EndpointAddress("net.tcp://localhost:12345"));                     
            c.Connecter(nom);
            (sender as Button).Enabled = false;
        }

        void MainForm_ReceptionMessage(object sender, MessageEventArgs e)
        {
            TextBox txtClient = null;
            switch ((sender as CallBack).Nom)
            {
                case "1":
                    txtClient = txtClient1;
                    break;

                case "2":
                    txtClient = txtClient2;
                    break;

                case "3":
                    txtClient = txtClient3;
                    break;

                case "4":
                    txtClient = txtClient4;
                    break;
            }

            txtClient.Text += e.Message + "\r\n";
        }
    }
}
